            implicit none
            integer N,nt,nfin,N0,j,ntsteps1,in_simu1_step,k,m
            integer ntsteps2,in_simu2_step,ntsteps3,in_simu3_step
            integer ntsteps4
            real*8 alpha, beta, gama,Lambda,mu,dt,IFR
            real*8 beta2,time,beta1, beta3
            real*8 nu,AS,AE,AI,AR,theta_nu_mp1
            real*8 kk,EE,sumat_s,sumat_e,sumat_i,sumat_r
c-----
            real*8 epsi,sim_time1,xfin1,xin1
             real*8 sim_time2,sim_time3,xfin2,xfin3,xin2,xin3,xin4,xfin4
            real*8 t1,t2,t3,t4,t5
            real*8 sim_time4
            real*8 dE
            real*8 dS
            real*8 dI
            real*8 dR
            real*8 S(0:10000000), E(0:10000000), I(0:10000000)
            real*8 R(0:10000000), Dt_t(0:10000000)
            real*8 R0,NN
            real*8 prod(1000000),combina(0:1000000)
            integer jmax,limit
            real*8 aux1,aux2,c0
            open(unit=1,file='susceptible.n')
            open(unit=2,file='exposed.n')
            open(unit=3,file='infected.n')
            open(unit=4,file='recovered.n')
c write deaths and deaths per day in this file
            open(unit=7,file='dead_individuals.n')
            open(unit=9,file='dead_individuals_per_day.n')
          !   initial data
          
             write(6,*)'NN_dead_ind_N0-NN.n is dead individuals'
          
            dt = 0.01d0
c MOD: AHORA NO HACE FALTA PONER UN DIA MENOS            
            t2 = 31.d0
            t3 = 50.d0
            t4 = 600.d0
        
        
c ----
            sim_time1 = t4
c ------
            
            xfin1 = sim_time1/dt
            
c MOD: ESTO VENIA DE t1            
            in_simu1_step = 1
            
            ntsteps1 = xfin1
            
            
            write(6,*)'simulation time1 (days) ',sim_time1
            write(6,*)'in_simu1_step           ',in_simu1_step
            write(6,*)' number of time steps 1 ', ntsteps1  
            write(6,*)'time step  (days)       ',dt
        
        
            N0 = 14839026.d0
            
            write(6,*)'N0 ',N0
            
            E(0) = 162.d0
            I(0) = 100.d0
            S(0) = N0 - E(0) - I(0)
            R(0) = 0.d0
            
            
c            I(0) = 0.001d0
c            E(0) = 0.d0
c            R(0) = 0.d0
c            S(0) = N0 - E(0) - I(0)
            
            
            write(6,*)'E(0) ',E(0)
            write(6,*)'S(0) ',S(0)
             write(6,*)'I(0) ',I(0)
             write(6,*)'R(0) ',R(0)
            
             NN =  N0
             mu = 1.d0/76.d0/365.d0
             nu = 0.9d0
       !      nu = 1.d0
             
             
             Lambda = mu* NN
             alpha = 0.00285d0 
             beta = 0.5d0
            
             beta = 0.50478d0
             beta1 = beta
             beta2 = 0.14343d0
             beta3 = 0.234   !fit 21 mayo
        
    
             epsi = 11.06d0
             epsi = 11.064d0
             
             epsi = 1.d0/epsi
             gama= 6.7420d0
             gama= 6.740d0 
             gama= 1.d0/gama
             
             
             jmax = ntsteps1
             write(6,*)'number of memory terms (jmax) ', jmax

c             beta2 = beta
c             beta3 = beta            
             
c --------       
            R0 = beta/(gama+ alpha)
            IFR = 100.d0*alpha/gama
            
      write(6,*)'parameters for time intervals t1, t2, t3 :', t1,t2,t3
            
            write(6,*)'*********************** '
            write(6,*)
            write(6,*)'nu                      ',nu 
            write(6,*)'jmax                    ',jmax
            write(6,*)'Lambda                  ',Lambda
            write(6,*)'mu                      ',mu
            write(6,*)'alpha                   ',alpha
            write(6,*)'beta1                   ',beta
            write(6,*)'beta2                   ',beta2
            write(6,*)'beta3                   ',beta3
            write(6,*)'epsi^{-1}               ',1/epsi
            write(6,*)'gama^{-1}              ',1/gama
            write(6,*)'R0 = beta1/(gama+alpha) ',R0
            write(6,*)'IFR                     ',IFR
            write(6,*)
            write(6,*)'*********************** '
             R0 = beta2/(gama+ alpha)
                write(6,*)'R02 = beta2/(gama+alpha) ',R0
             R0 = beta3/(gama+ alpha)
                write(6,*)'R03 = beta3/(gama+alpha) ',R0   
                
    
             if((dabs(nu-1.d0)).gt.1.d-14) then
c             write(6,*)'   combinatoric for nu =',nu
                    j=jmax
            
                 k=0
               combina(0)=1
              

               do 2 k=1,j
               kk = k
        
               combina(k)=combina(k-1)* (nu-kk+1)/kk
       
             
2             continue
              combina(0) = -1.d0
             do k=0,j
        
             combina(k) = (-1)**k * combina(k)
             write(77,*)'k, combina(k)= ck ',k, combina(k)
        
             enddo
        
                
               
c               write(6,*)'****************************'
c                write(6,*)
         !      do 20 k=1,j
                            
          !     combina(k)= (-1)**(k-1) * combina(k)
               
c              write(6,*)'j,k, combina(k) = C^{nu}_k ',k, combina(k)
!20         !     continue             
c             write(6,*)
c             write(6,*)'****************************'
             
  
             else
        
                 combina(1) = 1.d0
                 do k=2,20
                 combina(k) = 0.d0
                 enddo
                 do k=1,20
c           write(6,*)'   combinatoric for nu =',nu
c           write(6,*)'   combinatoric for k  =',k
c           write(6,*)'   combinatoric        =',combina(k)         
           
                   enddo
               endif        
                    
                
            write(6,*)'*****************************'
            write(6,*)'S(0) ',S(0)
            write(6,*)'E(0) ',E(0)
            write(6,*)'I(0) ',I(0)
            write(6,*)'R(0) ',R(0)
           
            write(6,*)'NN(0)   ',NN
            
             write(6,*)'*****************************'

 !              do m=1,1000
                          
  !    theta_nu_mp1 = (m+1)**(-nu)/gamma(1.d0-nu)
  !             write(77,*)m,theta_nu_mp1
  !              enddo
    
            
            
                in_simu1_step = 1 
c                write(6,*)' ntsteps1',ntsteps1
c
c !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
            

              do m=in_simu1_step,ntsteps1   
c
c
               write(6,*)' time step m',m
c                write(6,*)
                
            time=m*dt
                      if(time.ge.t2) beta=beta2
                      if(time.ge.t3) beta=beta3
        
                if((m-1).le.jmax)then
                limit = m
                else
                limit = jmax
                endif
                
                limit=m
                
                 
c                write(6,*)'m, limit',m, limit
c                write(6,*)
                
      theta_nu_mp1 = (m)**(-nu)/gamma(1.d0-nu)
c         theta_nu_mp1= 0.d0
c       write(6,*)'theta_nu_mp1 ',theta_nu_mp1
    
   
      AS = dt**nu*(Lambda-mu*S(m-1)-beta*S(m-1)*I(m-1)/NN)
      write(6,*)' before sumat m-1, AS ', m-1, AS

      
c      write(6,*)' '
      AE =dt**nu*(beta*S(m-1)*I(m-1)/NN -(mu + epsi)*E(m-1))
      write(6,*)' before sumat m-1, AE ', m-1, AE
      AI = dt**nu*(epsi*E(m-1) -(gama+mu + alpha)*I(m-1))
      write(6,*)' before sumat m-1, AI ', m-1, AI
      AR = dt**nu*(gama*I(m-1) - mu*R(m-1))
      write(6,*)' before sumat m-1, AR ', m-1, AR               
                
        
      
                
        
        
                
                     sumat_s = 0.d0
                    
                     
                do j = 1,limit
        sumat_s  = sumat_s   +  combina(j) * S(m-j)
c       write(6,*)'combina(j), m-j, S(m-j)',
c     1            combina(j), m-j, S(m-j)
c       write(6,*)
        

                enddo
            write(6,*)'sumat_s ',sumat_s
            
                c0 = 0.d0
                do j = 0,limit
          c0 = c0 + combina(j)
                enddo
                
           S(m) = AS  -sumat_s + c0*S(0) 
          
      write(6,*)' S(m) after  c0 ',S(m)
        write(6,*)
                                
                                    
              sumat_e = 0.d0
             
                do j = 1,limit
      sumat_e  = sumat_e +   combina(j) * E(m-j)
c                write(6,*)'combina(j), m-j, E(m-j)',
c     1    combina(j), E(m-j)
     
c      write(6,*)
            
                enddo
                
                c0 = 0.d0
                 do j = 0,limit
          c0 = c0 + combina(j)
                enddo
          
        
        E(m) = AE -sumat_e + c0*E(0)         
       write(6,*)'after c0  E(m)',E(m)         
c      write(6,*) 
    
            sumat_i = 0.d0
        
                do j = 1,limit
      sumat_i  = sumat_i +   combina(j) * I(m-j)
c        write(6,*)'combina(j),  m-j,I(m-j)',
c     1    combina(j),  m-j, I(m-j) 
c        write(6,*)
    
                enddo
    
                 do j = 0,limit
          c0 = c0 + combina(j)
                enddo       
            
        I(m) = AI  - sumat_i + c0*I(0)               
                
       write(6,*)'after c0  I(m)',I(m)           
c       write(6,*)
      
            sumat_r = 0.d0    
        
                do j = 1,limit
      sumat_r  = sumat_r -  combina(j) * R(m-j)
c        write(6,*)'combina(j), m-j, R(m-j)',
c     1    j, combina(j), m-j,R(m-j)  
c      write(6,*)
        
                enddo
                   do j = 0,limit
          c0 = c0 + combina(j)
                enddo                  
                
        
        R(m) = AR - sumat_r  +  c0*R(0)          
                
          write(6,*)'after c0 R(m)',R(m)          
c      write(6,*)
  
c      S(m) = AS + sumat_s
c      
c      E(m) = AE + sumat_e
c  
c      I(m) = AI + sumat_i
c      
c      R(m) = AR  + sumat_r
c      
       NN = S(m) + E(m) + I(m) + R(m)
      
          write(6,*)'NN(m) ',NN
          
         write(6,*)'  time step m ',m
         write(6,*)  
         write(6,*)'m, S(m) ',m, S(m)
         write(6,*)'m, E(m) ',m, E(m)
         write(6,*)'m, I(m) ',m, I(m)
         write(6,*)'m, R(m) ',m, R(m)
         write(6,*)'m, NN(m) ',m, NN
    
          write(6,*)'N0- NN(m)',m,N0-NN
          

c --------
            write(1,*)(m)*dt,S(m)
            write(2,*)(m)*dt,E(m)
             write(3,*)(m)*dt,I(m)
               write(4,*)(m)*dt,R(m)
C MOD: AHORA ESCRIBO TODO EN ESTE FILE
c deaths and deaths per day
                 write(7,*)time,(N0-NN)
                 
                  write(9,*)time,alpha*I(m) 
             Lambda = mu* NN
               if (m.eq.3) stop 55
            enddo
            
   
        
                write(6,*)' E(ntsteps1)',E(ntsteps1) 
                write(6,*)' I(ntsteps1)',I(ntsteps1)
                write(6,*)' S(ntsteps1)',S(ntsteps1)
                write(6,*)' R(ntsteps1)',R(ntsteps1)
                write(6,*)' N0 - E(ntsteps1)  ', 
     1          N0 - E(ntsteps1) 
        

              stop
               end
             
     
             
